/*
  Made By © Mustafa López & el "Rateret-Brut" del Culebrón-Xinorlet-Pinos (Alacant) 2020
*/

#include "hmg.ch"

FUNCTION Main

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  
  CLOSE DATABASES
*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET CODEPAGE TO UNICODE
*----------------------------------*
 
 PRIVATE nBitMask := GetLogicalDrives ()
 PRIVATE aDrives := {}

 dbCloseAll()

 USE DETECT
 ZAP

*----------------------------------*
    DEFINE WINDOW Form_1                ;
        AT 0,0                          ;
        WIDTH 437 HEIGHT 550            ;   
        BACKCOLOR {024,111,015}         ;     
        TITLE "USB Drive Detection"     ;
        ICON "Logo"                     ;
        MAIN NOMINIMIZE NOMAXIMIZE NOSIZE  ;  
        ON INIT ( Reserca_USB() , Hay_USB_YesNo() )

        ON KEY ESCAPE ACTION  Form_1.Release 


        DEFINE IMAGE Ima_Pen_1
           ROW 055 ; COL 045 ; WIDTH 340 ; HEIGHT 390  
           PICTURE "Resource\Imagen01.jpg"
           STRETCH .T.
        END IMAGE

                   
       @ 016,072 LABEL Label_00x VALUE OS() FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 300 HEIGHT 30  FONTCOLOR  { 250,250,250} BACKCOLOR { 024,111,015}       
*-------------------------- HD C: -----------------------------------------------------------------------------------------------------------------------------------*
       @ 075,183 LABEL Label_01x VALUE "-"+ HB_UChar(187)  FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 40 HEIGHT 40  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 }                  
       @ 068,219 LABEL Label_02x VALUE "" FONT "Arial" SIZE 30 BOLD ITALIC WIDTH 50 HEIGHT 50  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 } 

       @ 058,278 IMAGE Ima_Pen_2 PICTURE "Resource\Yes.jpg" WIDTH 063 HEIGHT 063  STRETCH 
*-------------------------- HD D: -----------------------------------------------------------------------------------------------------------------------------------*
       @ 150,183 LABEL Label_03x VALUE "-"+ HB_UChar(187)  FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 40 HEIGHT 40  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 }                  
       @ 143,219 LABEL Label_04x VALUE "" FONT "Arial" SIZE 30 BOLD ITALIC WIDTH 50 HEIGHT 50  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 } 

       @ 133,278 IMAGE Ima_Pen_3 PICTURE "Resource\Yes.jpg" WIDTH 063 HEIGHT 063  STRETCH 
*-------------------------- DVD D: ----------------------------------------------------------------------------------------------------------------------------------*
       @ 235,183 LABEL Label_05x VALUE "-"+ HB_UChar(187)  FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 40 HEIGHT 40  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 }                  
       @ 228,219 LABEL Label_06x VALUE "" FONT "Arial" SIZE 30 BOLD ITALIC WIDTH 50 HEIGHT 50  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 } 

       @ 218,278 IMAGE Ima_Pen_4 PICTURE "Resource\Yes.jpg" WIDTH 063 HEIGHT 063  STRETCH 
*-------------------------- USB & Memory Card F: --------------------------------------------------------------------------------------------------------------------*
       @ 315,183 LABEL Label_07x VALUE "-"+ HB_UChar(187)  FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 40 HEIGHT 40  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 }                  
       @ 308,219 LABEL Label_08x VALUE "" FONT "Arial" SIZE 30 BOLD ITALIC WIDTH 50 HEIGHT 50  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 } 

       @ 298,278 IMAGE Ima_Pen_5 PICTURE "Resource\Yes.jpg" WIDTH 063 HEIGHT 063  STRETCH 
*--------------------------------------------------------------------------------------------------------------------------------------------------------------------*
       @ 385,183 LABEL Label_09x VALUE "-"+ HB_UChar(187)  FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 40 HEIGHT 40  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 }                  
       @ 378,219 LABEL Label_10x VALUE "" FONT "Arial" SIZE 30 BOLD ITALIC WIDTH 50 HEIGHT 50  FONTCOLOR  { 000,000,000 } BACKCOLOR { 093,167,228 } 

       @ 368,278 IMAGE Ima_Pen_6 PICTURE "Resource\Yes.jpg" WIDTH 063 HEIGHT 063  STRETCH 

*--------------------------------------------------------------------------------------------------------------------------------------------------------------------*

             DEFINE BUTTON Button_3            
                     ROW    468
                     COL    148
                     WIDTH  130
                     HEIGHT 032
                     ACTION Form_1.Release     
                     CAPTION SPACE(6)-"Exit"   
                     FONTNAME "Arial"
                     FONTSIZE 9
                     TOOLTIP "Exit"   
                     FONTBOLD .T.
                     FONTITALIC .T.
                     PICTURE "Resource\Exit.Bmp" 
                     PICTALIGNMENT LEFT
             END BUTTON


    END WINDOW

             SETWINDOWCURSOR ( Form_1.Button_3.Handle, "Resource\SmoothHand.cur")

             HMG_ChangeWindowStyle ( GetControlHandle("Ima_Pen_1","Form_1"), LVS_REPORT, NIL, .T. )


    CENTER WINDOW  Form_1   
    ACTIVATE WINDOW Form_1

Return Nil

*----------------------------------------*
Function Reserca_USB()
*----------------------------------------*

 For i := 1 To 32
   If IsBit ( nBitMask , i )                 // <------ função IsBit da biblioteca LIBCT.LIB
              Aadd( aDrives, Chr(64+i)+":\" )
     Unit  := Aadd( aDrives, Chr(64+i) )
    dbAppend()
    REPLACE DETECT->LETRA WITH Unit
    skip+ 1

  EndIf
 Next i

  DBCLOSEAll()

Return NIL


*----------------------------------------*
Function Hay_USB_YesNo()
*----------------------------------------*

   SELECT 1
   USE  DETECT NEW
   LOCATE FOR  DETECT->LETRA = ALLTRIM("C") 

   IF FOUND()
      Form_1.Label_02x.VALUE := ALLTRIM(DETECT->LETRA) +":"
      Form_1.Ima_Pen_2.PICTURE := "Resource\Yes.jpg" 
   ELSE
      Form_1.Ima_Pen_2.PICTURE := "Resource\No.jpg" 
   ENDIF

   LOCATE FOR  DETECT->LETRA = ALLTRIM("D") 

   IF FOUND()
      Form_1.Label_04x.VALUE := ALLTRIM(DETECT->LETRA) +":"
      Form_1.Ima_Pen_3.PICTURE := "Resource\Yes.jpg" 
   ELSE
      Form_1.Ima_Pen_3.PICTURE := "Resource\No.jpg" 
   ENDIF

   LOCATE FOR  DETECT->LETRA = ALLTRIM("E") 

   IF FOUND()
      Form_1.Label_06x.VALUE := ALLTRIM(DETECT->LETRA) +":"
      Form_1.Ima_Pen_4.PICTURE := "Resource\Yes.jpg" 
   ELSE
      Form_1.Ima_Pen_4.PICTURE := "Resource\No.jpg" 
   ENDIF

  LOCATE FOR  DETECT->LETRA = ALLTRIM("F") 

   IF FOUND()
      Form_1.Label_08x.VALUE := ALLTRIM(DETECT->LETRA) +":"
      Form_1.Ima_Pen_5.PICTURE := "Resource\Yes.jpg" 
   ELSE
      Form_1.Ima_Pen_5.PICTURE := "Resource\No.jpg" 
   ENDIF


 LOCATE FOR  DETECT->LETRA = ALLTRIM("F") 

   IF FOUND()
      Form_1.Label_10x.VALUE := ALLTRIM(DETECT->LETRA) +":"
      Form_1.Ima_Pen_6.PICTURE := "Resource\Yes.jpg" 
   ELSE
      Form_1.Ima_Pen_6.PICTURE := "Resource\No.jpg" 
   ENDIF

Return Nil


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

#pragma BEGINDUMP

#include <windows.h>
#include <hbapi.h>
#include "hbapiitm.h" 

#ifndef __XHARBOUR__
   #define ISBYREF( n )          HB_ISBYREF( n )
   #define ISNIL( n )            HB_ISNIL( n )
#endif

// Code From WHAT32 by AJ Wos <andrwos@aust1.net> 

HB_FUNC(GETVOLUMEINFORMATION)
{
  char *VolumeNameBuffer     = (char *) hb_xgrab( MAX_PATH )  ;
  DWORD VolumeSerialNumber                                    ;
  DWORD MaximumComponentLength                                ;
  DWORD FileSystemFlags                                       ;
  char *FileSystemNameBuffer = (char *) hb_xgrab( MAX_PATH )  ;
  BOOL bRet;

  bRet = GetVolumeInformation( ISNIL(1) ? NULL : (LPCTSTR) hb_parc(1) ,
                                  (LPTSTR) VolumeNameBuffer           ,
                                  MAX_PATH                            ,
                                  &VolumeSerialNumber                 ,
                                  &MaximumComponentLength             ,
                                  &FileSystemFlags                    ,
                                  (LPTSTR)FileSystemNameBuffer        ,
                                  MAX_PATH ) ;
  if ( bRet  )
  {
     if ( ISBYREF( 2 ) )  hb_storc ((char *) VolumeNameBuffer, 2 )       ;
     if ( ISBYREF( 3 ) )  hb_stornl( (LONG)  VolumeSerialNumber, 3 )     ;
     if ( ISBYREF( 4 ) )  hb_stornl( (LONG)  MaximumComponentLength, 4 ) ;
     if ( ISBYREF( 5 ) )  hb_stornl( (LONG)  FileSystemFlags, 5 )        ;
     if ( ISBYREF( 6 ) )  hb_storc ((char *) FileSystemNameBuffer, 6 )   ;
  }

  hb_retl(bRet);
  hb_xfree( VolumeNameBuffer );
  hb_xfree( FileSystemNameBuffer );
}

HB_FUNC ( GETLOGICALDRIVES )
{
   hb_retnl( (DWORD) GetLogicalDrives() );
}

HB_FUNC ( GETDRIVETYPE )
{
   hb_retni( (UINT) GetDriveType(hb_parc(1)) );
}
HB_FUNC( SETERRORMODE )
{
   hb_retni( SetErrorMode( hb_parni( 1 ) ) ) ;
}

HB_FUNC( GETDISKFREESPACE ) // cRootPathName, @nSectorsByCluster, @nBytesPerSector,
                            // @nNumberOfFreeClusters, @nTotalNumberOfClusters --> lResult
{
   LPSTR lpRootPathName = hb_parc( 1 );
   DWORD SectorsPerCluster;
   DWORD BytesPerSector;
   DWORD NumberOfFreeClusters;
   DWORD TotalNumberOfClusters;

   hb_retl( GetDiskFreeSpace( lpRootPathName, &SectorsPerCluster,
                              &BytesPerSector, &NumberOfFreeClusters,
                              &TotalNumberOfClusters ) );
   hb_stornl( SectorsPerCluster, 2 );
   hb_stornl( BytesPerSector, 3 );
   hb_stornl( NumberOfFreeClusters, 4 );
   hb_stornl( TotalNumberOfClusters, 5 );
}
HB_FUNC( FILLBLUE )
{   
    HWND   hwnd;
    HBRUSH brush;
    RECT   rect;
    HDC    hdc;
    int    cx;
    int    cy;
    int    blue = 255;
    int    steps;
    int    i;

    hwnd  = (HWND) hb_parnl (1);
    hdc   = GetDC(hwnd);

    GetClientRect(hwnd, &rect);

    cx = rect.top;
    cy = rect.bottom;
    steps = (cy - cx) / 3;
    rect.bottom = 0;

    for( i = 0 ; i < steps ; i++ )
    {
        rect.bottom += 3;
        brush = CreateSolidBrush( RGB( 0, 148, blue ) );
        FillRect(hdc, &rect, brush);
        DeleteObject(brush);
        rect.top += 3;
        blue -= 1;
    }
    ReleaseDC(hwnd, hdc);
    hb_ret();
}
#pragma ENDDUMP

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

